#include<stdio.h>
#include<stdlib.h>
      #include <sys/types.h>
       #include <sys/stat.h>
       #include <fcntl.h>
       #include <termios.h>
       #include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <strings.h>
//#include <sys/io.h>

//GSI: 0x1D 0x49 0x01


#define TIMEOUTRETRYSTEP	10
#define SUCCESS 0
#define FAILURE -1

int m_iFD;

int Open(char * devName, unsigned int baudRate)
{

	struct termios TIO;
	int ret;

	m_iFD = open(devName, O_RDWR | O_NOCTTY | O_NDELAY );
	if (m_iFD < 0)
	{
		//printf("failed to open\n");
		return FAILURE;
	}

	bzero(&TIO, sizeof(TIO));
	switch (baudRate)
	{
		case 9600:
			TIO.c_cflag = B9600 | CS8 | CLOCAL | CREAD | CRTSCTS;
			break;

		case 19200:
			TIO.c_cflag = B19200 | CS7 | CLOCAL | CREAD | PARENB | PARODD;
			break;

		case 38400:
			TIO.c_cflag = B38400 | CS8 | CLOCAL | CREAD | CRTSCTS;
			break;

		case 57600:
			TIO.c_cflag = B57600 | CS8 | CLOCAL | CREAD | CRTSCTS;
			break;

		case 115200:
			TIO.c_cflag = B115200 | CS8 | CLOCAL | CREAD /*| CRTSCTS*/;
			break;
	}

	tcflush(m_iFD, TCIFLUSH | TCOFLUSH);
	tcsetattr(m_iFD,TCSANOW,&TIO);

	return SUCCESS;
}


int Close(void)
{

	
	if (m_iFD != -1)
	{
//		tcflush(m_iFD, TCIFLUSH | TCOFLUSH);
		close(m_iFD);
		m_iFD = -1;
	}

	return SUCCESS;
}

int PrintRow(unsigned char *strToPrint, int iLen)
{
		if (write(m_iFD, (unsigned char *)strToPrint  , iLen) < iLen)
		{
			printf("PrintRow Failed to print receipt row\n");
			return FAILURE;
		}

	return SUCCESS;
}

int PrintRowRetry(unsigned char *strToPrint, int iLen)
{
		int ret;

		ret = write(m_iFD, (unsigned char *)strToPrint  , iLen);
		if (write(m_iFD, (unsigned char *)strToPrint  , iLen) < iLen)
		{
			printf("PrintRow Failed to print receipt row\n");
			return FAILURE;
		}

	return SUCCESS;
}


int ReadRetryRaw(char * pbyteret, int len, int * bytes_read )
{

        int iRetry = 0;
	int read_len;


	if  ( (len <= 0) || (pbyteret == NULL) || (bytes_read==NULL)  ) 
		return FAILURE;
	
        while (iRetry < TIMEOUTRETRYSTEP)
	{
        	if ((read_len=read(m_iFD, pbyteret, len)) < 1)
         	{
                        iRetry++;
                        usleep(100 * 1000);                                                                                                     // 1 sec
                } else {
			*bytes_read = read_len;	
                        break;
                }
	}

	if ( iRetry == TIMEOUTRETRYSTEP )
		return FAILURE;

	return SUCCESS;
}

int ReadRaw(char * pbyteret, int len, int * bytes_read )
{

	int read_len;


	if  ( (len <= 0) || (pbyteret == NULL) || (bytes_read==NULL)  ) 
		return FAILURE;
	
        if ((read_len=read(m_iFD, pbyteret, len)) < 0)
		return FAILURE;

	*bytes_read = read_len;	
	return SUCCESS;
}

int main (int argc, char **argv)
{
	int res, ret;
	char str[256];
	char buf[256];
	int len, read_len;

	int i, mysercmd, status;

	res = Open(argv[1], 115200);
	if ( res == FAILURE )
		perror("open");
	
	str[0]=0x10;
	str[1]=0x04;
	str[2]=0x14;
	len = 3;

    unsigned int iLoop;
    iLoop = 20;

    printf("Asking printer status for 20 seconds...\n");
    for (iLoop = 0; iLoop < 60 ; iLoop++)
    {
	    res = PrintRow(str, len);
	    if ( res == FAILURE )
    		perror("write");
    
    
    	len=12;
    	//ReadRetryRaw(buf, 256, &len);
    	for(i=0; i<10 ; i++)
    	{
    	ReadRaw(buf, 256, &len);
    	printf("recv len=%d\n", len);
    	if ( len > 0 )
    		break;
    	sleep(1);
    	}
    	if ( len > 0 )
    	{
    	printf("recv bytes: ", len);
    	for(i=0; i<len;i++)
    		printf("0x%x ", (unsigned char)buf[i]);
    	}
    	printf("%s\n", " END");
    
    	sleep (1);

    }
        res = Close();
	
}
